/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.custom.selectitems;

import javax.faces.component.UIComponent;
import javax.faces.el.ValueBinding;
import javax.faces.context.FacesContext;


// Generated from class org.apache.myfaces.custom.selectitems.AbstractUISelectItems.
//
// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
public class UISelectItems extends org.apache.myfaces.custom.selectitems.AbstractUISelectItems
{

    static public final String COMPONENT_FAMILY =
        "javax.faces.SelectItems";
    static public final String COMPONENT_TYPE =
        "org.apache.myfaces.UISelectItems";


    public UISelectItems()
    {
        setRendererType(null);
    }

    public String getFamily()
    {
        return COMPONENT_FAMILY;
    }
    

    // Property: var
    private String _var;
    
    public String getVar()
    {
        if (_var != null)
        {
            return _var;
        }
        ValueBinding vb = getValueBinding("var");
        if (vb != null)
        {
            Object value = vb.getValue(getFacesContext());
            if (value == null)
            {
                return null;
            }
            else
            {
                return (String) value.toString();
            }
        }
        return null;
    }

    public void setVar(String var)
    {
        this._var = var;
    }
    // Property: itemLabel
    private Object _itemLabel;
    
    public Object getItemLabel()
    {
        if (_itemLabel != null)
        {
            return _itemLabel;
        }
        ValueBinding vb = getValueBinding("itemLabel");
        if (vb != null)
        {
            return  vb.getValue(getFacesContext());
        }
        return null;
    }

    public void setItemLabel(Object itemLabel)
    {
        this._itemLabel = itemLabel;
    }
    // Property: itemValue
    private Object _itemValue;
    
    public Object getItemValue()
    {
        if (_itemValue != null)
        {
            return _itemValue;
        }
        ValueBinding vb = getValueBinding("itemValue");
        if (vb != null)
        {
            return  vb.getValue(getFacesContext());
        }
        return null;
    }

    public void setItemValue(Object itemValue)
    {
        this._itemValue = itemValue;
    }
    // Property: useEntryAsItem
    private boolean _useEntryAsItem;
    
    private boolean _useEntryAsItemSet;
    
    public boolean isUseEntryAsItem()
    {
        if (_useEntryAsItemSet)
        {
            return _useEntryAsItem;
        }
        ValueBinding vb = getValueBinding("useEntryAsItem");
        if (vb != null)
        {
            return ((Boolean) vb.getValue(getFacesContext())).booleanValue();
        }
        return false; 
    }

    public void setUseEntryAsItem(boolean useEntryAsItem)
    {
        this._useEntryAsItem = useEntryAsItem;
        this._useEntryAsItemSet = true;        
    }

    public Object saveState(FacesContext facesContext)
    {
        Object[] values = new Object[6];
        values[0] = super.saveState(facesContext);
        values[1] = _var;
        values[2] = _itemLabel;
        values[3] = _itemValue;
        values[4] = Boolean.valueOf(_useEntryAsItem);
        values[5] = Boolean.valueOf(_useEntryAsItemSet);
        return values; 
    }

    public void restoreState(FacesContext facesContext, Object state)
    {
        Object[] values = (Object[])state;
        super.restoreState(facesContext,values[0]);
        _var = (java.lang.String) values[1];
        _itemLabel =  values[2];
        _itemValue =  values[3];
        _useEntryAsItem = ((Boolean) values[4]).booleanValue();
        _useEntryAsItemSet = ((Boolean) values[5]).booleanValue();
    }
}
